<template>
    <table class="table table-bordered bg-white shadow-sm">
        <thead>
        <tr class="align-middle text-center">
            <th colspan="1"></th>
            <th colspan="4">Tűzoltó készülék</th>
            <th colspan="1">Gyártás</th>
            <th colspan="4">Ellenörzések időpontja</th>
            <th colspan="1">Karbantartás időpontja</th>
            <th colspan="1">Eszköz megj.</th>
            <th colspan="1"></th>
        </tr>
        <tr class="align-middle text-center">
            <th></th>
            <th></th>
            <th>Gyári szám</th>
            <th>Készenléti helye</th>
            <th>Típusa</th>
            <th></th>
            <th>I. n.év</th>
            <th>II. n.év</th>
            <th>III. n.év</th>
            <th>IV. n.év</th>
            <th></th>
            <th></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        <tr v-for="(extinguisher, key) in extinguishers" :key="key" class="align-middle text-center"
            :class="[extinguisher.hasMaintenance ? 'table-success' : 'table-danger']">
            <td :class="[extinguisher.hasMaintenance ? 'table-border-green' : 'table-border-red']">
                <div class="p-3">
                    {{ extinguisher.id }}
                </div>
            </td>
            <td>
                <div class="mb-3">
                    <Button icon="pi pi-list" severity="danger"
                            @click="openMaintenanceListDialog(extinguisher)" :disabled="extinguisher.maintenances.length === 0" />
                </div>
                <div>
                    <Button icon="pi pi-wrench" severity="danger"
                            @click="openMaintenanceDialog(extinguisher)" :disabled="extinguisher.fourthMaintenance" />
                </div>
            </td>
            <td>{{ extinguisher.serialNumber }}</td>
            <td>{{ extinguisher.location }}</td>
            <td>{{ extinguisher.extinguisherTypeText }}</td>
            <td>{{ extinguisher.productionTimeStr }}</td>
            <td>
                <div class="border border-secondary p-2 text-secondary text-nowrap m-auto" v-if="extinguisher.firstMaintenance">
                    {{ extinguisher.firstMaintenance.maintenanceTime }}
                </div>
            </td>
            <td>
                <div class="border border-secondary p-2 text-secondary text-nowrap m-auto" v-if="extinguisher.secondMaintenance">
                    {{ extinguisher.secondMaintenance.maintenanceTime }}
                </div>
            </td>
            <td>
                <div class="border border-secondary p-2 text-secondary text-nowrap m-auto" v-if="extinguisher.thirdMaintenance">
                    {{ extinguisher.thirdMaintenance.maintenanceTime }}
                </div>
            </td>
            <td>
                <div class="border border-secondary p-2 text-secondary text-nowrap m-auto" v-if="extinguisher.fourthMaintenance">
                    {{ extinguisher.fourthMaintenance.maintenanceTime }}
                </div>
            </td>
            <td>
                <div class="border border-secondary p-2 text-secondary w-50 text-nowrap m-auto" v-if="extinguisher.maintenanceTime">
                    {{ extinguisher.maintenanceTime }}
                </div>
            </td>
            <td>{{ extinguisher.note }}</td>
            <td>
                <Button icon="pi pi-pencil" severity="warning"
                        @click="openEditDialog(extinguisher)" />
            </td>
        </tr>
        </tbody>
    </table>
</template>

<script>
import Button from "primevue/button";

export default {
    name: "extinguisherTable",
    components: {
        Button
    },
    props: {
        extinguishers: {
            type: Array
        }
    },
    emits: ["createMaintenance", "maintenanceList", "edit"],
    methods: {
        openMaintenanceDialog(extinguisher) {
            this.$emit('createMaintenance', extinguisher);
        },
        openMaintenanceListDialog(extinguisher) {
            this.$emit('maintenanceList', extinguisher);
        },
        openEditDialog(extinguisher) {
            this.$emit('edit', extinguisher);
        },
    }
}
</script>

<style scoped>

</style>
